#if !defined( _JCSVFileReaderObj_h )
#define _JCSVFileReaderObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"
#include "JFile.h"
#include "JFileInputStream.h"

#include <stdio.h>

class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JCSVFileReaderObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      ON,
      TICK,
      NUMBERRECORDS };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JCSVFileReaderObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
  private:

    // controls
    int on;
    int tick;
    int numberRecords;

    // properties
    JString file;

	JFile inFile;
	FILE* inputStream;
	int inStreamAvailable;

    // outputs
    int r0;
    int r1;
    int r2;
    int r3;
    int r4;
    int r5;
    int r6;
    int r7;
    int r8;
    int r9;
    int r10;
};


#endif
